; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;				PreOs	Kernel
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

; Update: 3 kinds of update may come. Search for the code in the install process
;	to update PreOS. Search for the string :
;		Check if BOOT Update
;		Check if AMS Update
;		Check if HARDWARE Update
;	

; Bugs :
;	Bug avec txtrider ?
;	Bug avec Total Destruction ?
;	Bug avec ziplib + txtrider textes archives ?
;	Bug avec AMS 2.08 ?
; To Do :
;	Ameliorer l'auto run (Free preos) ?
;	kernel::LibsExec is NOT reentrant
;	To do a starter which install the kernel and then run a program.
;	Export all dirty Hacks of Tigcc : realloc, vcbprintf, HS_pushEmptyFIFONode, ... ?
;	Delete graphlib, userlib, filelib, pk92lib, (stdlib) & doorsos & install & kernel & teos

;	Remove $4C (...) & install_preos
;	addr = (AMS 1.00 ? xxx : cmd_try+xxx)
;	hd = Ptr2Hd(*addr);
;	if (Kernel Signature)
;		AutoRun = True
;		Prog Handle = hd // Pb a la sortie car Pack Archive auto-detruites !
;	else if (Argv[1] = file)
;		SymFind
;		if (Kernel Signature)
;			AutoRun = True;
;			Prog Handle = hd;
;	if (!AutoRun)
;		Install Hw2Tsr
;		Block = Alloc Space for block
;	else	Block = Inside Preos
;		Save Vectors
;		enter_ghost_space
;	Install Process
;	if (!AutoRun)
;		Display infos
;	else	Run program (Pb nostub anticrash ?)

	include "include/RomCalls.h"

	xdef 	_ti89
	xdef	_nostub

;Define this if you want to debug Iceberg:
;VTI EQU 1
 ifd VTI
ROM_base equ $200000
 endc
 ifnd VTI
ROM_base equ $800000
 endc

PREOS_VERSION	EQU	$0100*65536+'IC'	; Iceberg version
VERSION_OFFSET	EQU	$10			; Offset of the version number
ROM_VECTOR	EQU	$012088			; Offset from ROM_BASE to get the original vectors

_main:
	; Test if the call is from Ti-Home
	cmp.l	#$200000,(a7)
	bls	dont_install

	movem.l d3-d7/a2-a6,-(a7)
	
	; Load Global registers
	move.l	a7,a6			; Saving Sp
	move.l	($C8).w,a5		; Rom_calls ptr
	
	; Test presence kernel...
	lea	already(Pc),a0
	tst.w	($30).w			; Regarde si un kernel est dj install
	bne	exit

	; Get ROM_BASE.
	movea.l	#ROM_base,a4			; Rom_base
 ifd VTI
	moveq	#0,d5			; HW_REVISION = 0
	moveq	#1,d3			; HW_VERSION = 1
 endc
 ifnd VTI
	moveq	#2,d5			; HW_REVISION = 2
	moveq	#3,d3			; HW_VERSION = 3
 endc
	moveq	#0,d0		; 89
	
	;1 : save calc/hardware
	lea	Calc(pc),a3
	move.b	d0,(a3)+		; Save Calculator
	move.b	d3,(a3)+		; Save Hardware Version
	move.b	d5,(a3)+		; Save HW_REVISION_VERSION (Useless)
	clr.b	(a3)+		; Save Emulator Flag
	lea	RAM_TABLE+$e*4(pc),a3
	
	;2 : Find FontMedium (It takes only 0.02s to find it.) (Check if BOOT Update).
	move.l	a4,a0
\fontloop:	cmp.l	#$54A854A8,(a0)+
		bne.s	\fontloop
	subq.l	#4,a0
	move.l	a0,(a3)+
	clr.l	(a3)+			; ReturnValue is calculated later.

	;3: Find tios::kb_vars (Check if AMS Update).
	moveq	#6,d0			; 6 = Key Queue address
	trap	#9			; Call system
	lea	($6-$1C)(a0),a0		; Fix to get kb_vars
	move.l	a0,(a3)+

	; 3': Find ST_flags (On rom 2.0x and 3.0x there is a rom_call )
	FAST_ROM_PTR $443,a5
	addq.w	#3,a0
	lea	Statut+4(Pc),a1
	move.w	a0,(a1)			; Statut ADR

	;4: Find Heap (On rom 2.0x and 3.0x there is a rom_call )
	FAST_ROM_PTR $441,a5 ;get address of HeapTable
	bclr.b	#2,$600001
	move.l a0,$fc ;stupid SMQ uses word relocs for Heap, so make it happy
	bset.b	#2,$600001
	move.l	#$fc,(a3)+			; tios::Heap

	;5: Find main, its handle and the handle of FolderListHandle
	pea	main_str_end(Pc)
	FAST_ROM_CALL SymFindHome,a5
	move.l	d0,d1
	clr.w	d1
	swap	d1
	move.l	d1,(a3)+	; FolderHandle
	move.l	d0,(a7)
	FAST_ROM_CALL DerefSym,a5
	move.w	SYM_ENTRY.hVal(a0),d0	;MainHandle
	moveq	#0,d1
	move.w	d0,d1
	move.l	d1,(a3)+	; MainHandle
	
	;6: Find the ROM version number.
	; Par Kevin Kofler (Modifie par PpHd)
	move.l	$440*4(a5),a0 	; Get address of AMS version ROM_CALL
	moveq	#$30,d0 
	move.b	Calc(Pc),d1
	lsl.w	#4,d1
	add.b	(a0),d1
	sub.b	d0,d1
	lsl.w	#4,d1
	addq.l	#2,a0
	add.b	(a0)+,d1
	sub.b	d0,d1
	lsl.w	#4,d1
	add.b	(a0)+,d1
	sub.b	d0,d1
	move.l	d1,(a3)+

	; Find LCD_MEM (Hum) 
	lea	4*($21-$15)(a3),a3
	move.l	#LCD_MEM,(a3)+
	
	; Find font_small (It takes only 0.02s to find it.) (Check if BOOT Update).
	move.l	a4,a0
\fontsmall_loop	cmp.l	#$0450A050,(a0)+
		bne.s	\fontsmall_loop
	subq.l	#4,a0
	move.l	a0,(a3)+
	
	; Find font_medium (It takes only 0.02s to find it.) (Check if BOOT Update).
	move.l	a4,a0
\fontmed_loop	cmp.l	#$55AA55AA,(a0)+
		bne.s	\fontmed_loop
	subq.l	#4,a0
	move.l	a0,(a3)+

	; Desciption of a SYM_ENTRY struct
	moveq	#0,d0
	move.l	d0,(a3)+	; Name
	moveq	#8,d0
	move.l	d0,(a3)+	; Compat
	moveq	#10,d0
	move.l	d0,(a3)+	; Flags
	moveq	#12,d0
	move.l	d0,(a3)+	; hVal
	moveq	#14,d0
	move.l	d0,(a3)+	; sizeof
	
 ifnd VTI
	;7 : Check HW3Patch
	; Check if there is HW2Patch sur Rom 2.0x par KK (Check if AMS + HW2 Update).
	FAST_ROM_PTR EX_stoBCD,a5	; Well, the function which follows EX_stoBCD is the protect function
	tst.w	92(a0)		; Check for HW2Patch (ROM resident)
	beq.s	\_hw1		; Ok, there is HW2 Patch
	cmp.l	#$100,($ac).w	; Check for HW2Patch (RAM resident)
	beq.s	\_hw1		; Ok, there is HW2 Patch (Trap B is intercepted)
		lea	hw3patch_str(Pc),a0
		bra	exit
\_hw1:
 endc

	; 8 Gestion EV_hook
	FAST_ROM_PTR EV_hook,a5
	lea	EV_hook2+2(pc),a1
	move.l	a0,(a1)				; Save EV_hook during kernel calls.
	move.l	a0,EV_hook3-EV_hook2(a1)
	move.l	a0,EV_hook4-EV_hook2(a1)
	
	; 9 Gestion idle
	FAST_ROM_PTR idle,a5		; (Check if AMS Update).
	lea	idleN+2(pc),a1
	move.w	2(a0),(a1)		; get idle number identification
		
	; 9' : Gestion top_estack	(<= SHIFT+ ON)
	FAST_ROM_PTR	top_estack,a5
	lea	top_estack1+2(pc),a1
	move.w	a0,(a1)
	move.w	a0,(top_estack2-top_estack1)(a1)
		
	; 10: Gestion intiale value of contrast
	moveq	#4,d0
	trap	#9				; (Check if AMS Update).
	lea	orgcontrast+3(Pc),a1
	move.b	(a0),d0
	subq.b	#1,d0
	move.b	d0,(a1)+	; Save Contrast Value
	move.w	a0,(a1)		; Save Contrast addr

	; 11: Find the address of the error-frame list 
	FAST_ROM_PTR ER_success,a5		; Get ER_success ptr
	lea	ErrorFrameAdr+2(pc),a1		;(Check if AMS Update).
	move.w	2(a0),d0
	bne.s	\erframeok
	move.w	4(a0),d0
\erframeok	move.w	d0,(a1)
	move.w	d0,ErrorFrameAdr2-ErrorFrameAdr(a1)
	move.w	d0,ErrorFrameAdr3-ErrorFrameAdr(a1)
	
	; 12 Find 3 secret functions of AMS (Check if AMS Update).
	; Recherche de trois fonctions d'AMS cachees
	; Attention, c'est assez complique a trouver (mais indispensable).
	; Un clr.l FirstWindow n'est pas suffisant sur AMS 2.03 :(
	; C'est pour ca que je recherche ces fonctions !
	movea.l	#ROM_base+$012088+4,a1	; Get Vector Table
	move.l	(a1),a1			; Read Org Reset vector
					; FIX ME : move.l ($4).w,a1 may be ok ?
	; The searched code looks like
	; move.l #$DEADDEAD,$4200
	; clr.l $5D86
	; bsr.s 
	; bsr.s 
	; bsr.s 
	; bsr.s 
	; bsr.s 
	; bsr.s 
	; bsr.s +$36			; The first  function we search
	; move.w #$00,SR
	; jmp tios::EV_CentralDispatcher
\search_dead:
		subq.l	#2,a1
		cmp.l	#$DEADDEAD,(a1)+
		bne.s	\search_dead
	FAST_ROM_PTR EV_centralDispatcher,a5
\search_EV
		subq.l	#2,a1
		cmp.l	(a1)+,a0
		bne.s	\search_EV
	move.l	($41248C-$412462+2)(a1),a1	; The searched function is in a1
	; Now it looks like
	;link	a6
	;movem  ...,x(a6)
	;tst.l	$5D7C.l
	;bne.s 
	;jsr	$			; The 1st : Reset a flag (I don't know what it does exactly !)
	;jsr	$			; The 2nd : Reset PortRestore / SetCurrentClip / ScreenClear(:() / FontSetSys + Some flags
	;jsr	$			; The 3rd : Reset the window list + Some Flags
	lea	AMS_HiddenFunc+2(Pc),a0
	move.l	28(a1),(a0)		; Read the 2nd function.
	move.l	34(a1),6(a0)	; Read the 3rd function.

	;13 : Alloc memory
	pea	(blocfin-bloc).w
	FAST_ROM_CALL HeapAllocHigh,a5
	move.w	d0,(a7)
	bne.s	\inst
		lea	memory(Pc),a0
		bra	exit
\inst	

	;14 : Install Kernel infos (Check if HARDWARE Update).
	bclr.b	#2,$600001
	lea	$30,a4
	move.l	#PREOS_VERSION,(a4)+	; $30=version + $FF for protection against the jsr /jmp $0 / $32=identifiant

	move.w	(a7),$14(a4)		; $48=handle du bloc

	FAST_ROM_CALL HeapDeref,a5	; Deref the Handle a0

	; 15 Install interrupts
	lea	crash_handler-bloc(a0),a2		; Install crash handler
	moveq	#7-1,d0
	lea	($8+$4),a3
\loop_handler:		move.l  a2,(a3)+		; Install new one
			dbra    d0,\loop_handler

	; NOTE: On all roms, there is a move.w $00,d0 (You can get it by setting a data break point to 0, and go to graph mode).
	; I think it is a bug in AMS, since it is non-sens.
	
	lea	newER_throw-bloc(a0),a2	;l'adresse o sera ER_throw
	lea	OldER_throw+2(Pc),a3
	move.l	-12(a4),(a3)		;$28
	move.l	a2,-12(a4)		;$28

	lea	new1111-bloc(a0),a2	;l'adresse o sera LineEmulator 1111
	move.l	a2,-8(a4)		;$2C

	lea	oldint6+2(Pc),a2
	move.l	($64+5*4).w,(a2)
	lea	newint6-bloc(a0),a1
	move.l	a1,$64+5*4

	; 16 RAMCALLS gestion (end part)
	lea	RAM_TABLE(pc),a3
	lea	Calc-bloc(a0),a2	;l'adresse o sera CALC
	move.l	a2,(a3)			;place l'adresse de CALC

	lea	RetVal-bloc(a0),a2	; L'adresse ou sera RetVal
	move.l	a2,($F*4)(a3)		; Sauver

	lea	($15*4)(a3),a1
	lea	kernel::idle-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::exec-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::Ptr2Hd-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::Hd2Sym-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::LibsBegin-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::LibsEnd-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::LibsCall-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::LibsPtr-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::LibsExec-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::HdKeep-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::ExtractFromPack-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::ExtractFile-bloc(a0),a2
	move.l	a2,(a1)+
	lea	kernel::ExtractFileFromPack-bloc(a0),a2
	move.l	a2,$29*4(a3)

	; 19 Relocation du trap #0
	lea	NewTrap0-bloc(a0),a1
	lea	Trap0Adr+2(Pc),a2
	move.l	a1,(a2)

	lea	ResetTrap0-bloc(a0),a1
	lea	resetTrap0Adr+2(Pc),a2
	move.l	a1,(a2)

	; 21 Write standard exported functions.
	move.l	a0,(a4)+		; exec function is the first one
	lea	reloc-bloc(a0),a1
	move.l	a1,(a4)+
	lea	reloc2-bloc(a0),a1
	move.l	a1,(a4)+
	lea	unreloc-bloc(a0),a1
	move.l	a1,(a4)+
	lea	unreloc2-bloc(a0),a1
	move.l	a1,(a4)+
	lea	ExeArchive-bloc(a0),a1
	move.l	a1,$50
	bset.b	#2,$600001

	; 21 Copy the kernel into a Terminate and stay resident Handle
	lea	bloc(pc),a1
	move.w	#-1+(blocfin-bloc),d0
\copy:		move.b	(a1)+,(a0)+
		dbra	d0,\copy
	; The KERNEL is installed

	lea	-1000(a7),a7
	move.l	a7,a4
	move.w	#(blocfin-bloc),-(a7)
	pea	success(pc)
	pea	(a4)
	ROM_THROW sprintf
	move.l	a4,a0			; Vicieux ;)

	; In: a0-> String to print
exit:
	pea	(1).w
	pea	(a0)
	pea	iceberg_title(pc)
	FAST_ROM_CALL DlgMessage,a5		; Can be called even if UniOs is installed !

	; Install new auto-ints and ev_hook
	moveq	#7-1,d0
	lea	($64),a1
	lea	($E0-$64)(a1),a2
	bclr.b	#2,$600001
\loop_autoint:	move.l  (a1)+,(a2)+	; Save old handler
		dbra    d0,\loop_autoint
	bset.b	#2,$600001

	move.l	a6,a7			; Pop Stack
	
	; Test if run program
	move.l	($4C).w,d0
	beq.s	\no_run
		; To do : Reduce Preos space if it was a twin entry.
		;	lea	0(pc),a0
		;	bsr	kernel::Ptr2Hd
		;	bsr	Hd2Sym
		;	btst.b	#,SYM_ENTRY.flags(a0)
		;	...
		;		Copy code de reduction, de code d'execution, de desinstallation dans la RAM a addr fixe (HW2TSR) -Stack
		;		saut 
		bclr.b	#2,$600001
		clr.l	$4C
		bset.b	#2,$600001
		move.l	d0,a0
		bsr	kernel::Ptr2Hd
		bsr	kernel::exec		; Bugs ? Nan
		; To do Uninstall : pb hw2tsr.........................................................
		; In Tictex, si kernel prgm et pas kernel ($30), call preos() en mettant a $4C l'adresse du programme ?
\no_run	
	; Quit program
	movem.l (a7)+,d3-d7/a2-a6
dont_install
	rts
	
; Terminate and Stay Resident Part of Preos
bloc:
	include "Exec.asm"		; Exec Kernel Programs
	include	"Reloc.asm"		; Reloc Kernel Programs
	include "Ints.asm"		; Interrupts
	include	"ext.asm"		; External Functions
blocfin:

	; Strings
iceberg_title	dc.b "Iceberg v1.00",0		; Title
success		dc.b "Success ! (%u bytes)",0
already		dc.b "Update auto-ints.",0
hw3patch_str	dc.b "Install HW3Patch first",0
memory		dc.b "Not enough memory",0
		dc.b	0,"main"
main_str_end	dc.b	0

	end
	